/*
 * Name
 *  bilinear_f.c -- use bilinear interpolation with fallback for given row, col
 *
 * Description
 *  bilinear interpolation for the given row, column indices.
 *  If the interpolated value (but not the nearest) is null,
 *  it falls back to nearest neighbor.
 */

#include <grass/gis.h>
#include "r.proj.h"

int p_bilinear_f(struct cache *ibuffer,	/* input buffer                  */
		void *obufptr,	/* ptr in output buffer          */
		int cell_type,	/* raster map type of obufptr    */
		double *col_idx,	/* column index          */
		double *row_idx,	/* row index                     */
	    struct Cell_head *cellhd	/* cell header of input layer    */
    )
{
    if (p_bilinear(ibuffer, obufptr, cell_type,
		             col_idx, row_idx, cellhd))
		return p_nearest(ibuffer, obufptr, cell_type,
		                 col_idx, row_idx, cellhd);
    return 0;
}
